/*
Complexitate timp: O(P^2)
60 puncte
*/
#include <stdio.h>
#define PMax 100005

FILE *fin = fopen("piscina.in", "rt");
FILE *fout = fopen("piscina.out", "wt");

int n, m, p;
int x[PMax], y[PMax];

void mirror(int *d, int n) {
	for (int i = 0; i < p - 1; i++) {
		d[i] = n - d[i];
	}
}

int getArea00() {
	int aMax = 0, a;
	for (int i = 0; i < p; i++) {
		// pool under y[i];
		int xmin = n + m - y[p - 1];
		for (int j = 0; j < p; j++) {
			if (y[j] < y[i] && xmin > x[j]) {
				xmin = x[j];
			}
		}
		a = y[i];
		a *= xmin;
		if (aMax < a) {
			aMax = a;
		}
	}
	return aMax;
}

int main() {

	fscanf(fin, "%d %d %d", &n, &m, &p);
	for (int i = 0; i < p; i++) {
		fscanf(fin, "%d %d", &x[i], &y[i]);
	}
	x[p] = 0; y[p] = m;
	p++;

	int aMax = 0, area;
	area = getArea00(); if (aMax < area) { aMax = area; }
	mirror(x, n);
	area = getArea00(); if (aMax < area) { aMax = area; }
	mirror(y, m);
	//y[p - 1] = n;
	area = getArea00(); if (aMax < area) { aMax = area; }
	mirror(x, n);
	area = getArea00(); if (aMax < area) { aMax = area; }

	fprintf(fout, "%ld\n", aMax);
	fclose(fin);
	fclose(fout);
	return 0;
}